--来源：LivvenUI
--作者：L
--修改：
local LUI, T, E, L, V, P, G = unpack(select(2, ...))
if LUI:CheckDB("modules", "unitframes", "partyframe", "partyHealerManaOnly", "enable") == true then return end
local LPHMO = E:NewModule("LuiPartyHealerManaOnly", "AceEvent-3.0")

local function SetPartyHealerManaOnly(self)
    if self:IsForbidden() or not self:IsVisible() or not self.buffFrames or not DefaultCompactUnitFrameSetupOptions.displayPowerBar then return end
    local barHeight = T.UnitGroupRolesAssigned(self.unit) == "HEALER" and 8 or 0
    self.healthBar:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -1, 1 + barHeight)
    self.buffFrames[1]:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -3, CUF_AURA_BOTTOM_OFFSET + barHeight)
    self.debuffFrames[1]:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", 3, CUF_AURA_BOTTOM_OFFSET + barHeight)
end

local function SetElvUIPartyHealerManaOnly()
    if T.IsInRaid() then return end
    if T.IsInGroup() then
        local members = T.GetNumGroupMembers()
        for i = 1, members do
            local frame = _G["ElvUF_PartyGroup1UnitButton" .. i]
            frame.Power:Hide()
            if i == 1 then
                local role = T.UnitGroupRolesAssigned("player")
                if role == "HEALER" then frame.Power:Show() end
            else
                local k = i - 1
                local role = T.UnitGroupRolesAssigned("party" .. k)
                if role == "HEALER" then frame.Power:Show() end
            end
        end
    end
end

function LPHMO:Initialize()
    if E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly["partyElvUI"] then
        self:RegisterEvent("PLAYER_ENTERING_WORLD", SetElvUIPartyHealerManaOnly)
        self:RegisterEvent("GROUP_ROSTER_UPDATE", SetElvUIPartyHealerManaOnly)
    end
    
    if E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly["partyBlizzard"] then
        T.hooksecurefunc("CompactUnitFrame_UpdateAll", SetPartyHealerManaOnly)
    end
end

local function InitializeCallback()
    if not E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly["enable"] then return end
    LPHMO:Initialize()
end

E:RegisterModule(LPHMO:GetName(), InitializeCallback)
