local LUI, T, E, L, V, P, G = unpack(select(2, ...))

local function configTable()
	E.Options.args.lui.args.modules.args.unitframes = {
        order = 13,
		type = "group",
		childGroups = "tab",
        name = L["unitframes"],
        get = function(info)
            return E.db.lui.modules.unitframes[info[#info]]
        end,
        set = function(info, value)
            E.db.lui.modules.unitframes[info[#info]] = value
            E:StaticPopup_Show("PRIVATE_RL")
        end,
        args = {
			name = {
				order = 0,
				type = "header",
				name = LUI:cOption(L["unitframes"]),
            },
            partyframe = {
                order = 1,
                type = "group",
                name = L["partyframe"],
                get = function(info)
                    return E.db.lui.modules.unitframes.partyframe[info[#info]]
                end,
                set = function(info, value)
                    E.db.lui.modules.unitframes.partyframe[info[#info]] = value
                    E:StaticPopup_Show("PRIVATE_RL")
                end,
                args = {
                    partyHealerManaOnly = {
                        order = 1,
                        type = "group",
                        guiInline = true,
                        name = L["partyHealerManaOnly"],
                        get = function(info)
                            return E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly[info[#info]]
                        end,
                        set = function(info, value)
                            E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly[info[#info]] = value
                            E:StaticPopup_Show("PRIVATE_RL")
                        end,
                        args = {
                            enable = {
                                order = 1,
                                type = "toggle",
                                name = L["Enable"],
                            },
                            spacer1 = {
                                order = 2,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly["enable"]
                                end,
                            },
                            partyElvUI = {
                                order = 3,
                                type = "toggle",
                                name = L["partyElvUI"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly["enable"]
                                end,
                            },
                            partyBlizzard = {
                                order = 4,
                                type = "toggle",
                                name = L["partyBlizzard"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.partyframe.partyHealerManaOnly["enable"]
                                end,
                            },
                        },
                    },
                },
            },
            playerframe = {
                order = 2,
                type = "group",
                name = L["playerframe"],
                get = function(info)
                    return E.db.lui.modules.unitframes.playerframe[info[#info]]
                end,
                set = function(info, value)
                    E.db.lui.modules.unitframes.playerframe[info[#info]] = value
                    E:StaticPopup_Show("PRIVATE_RL")
                end,
                args = {
                    gcdBar = {
                        order = 1,
                        type = "toggle",
                        name = L["gcdBar"],
                    },
                    swingBar = {
                        order = 1,
                        type = "group",
                        guiInline = true,
                        name = L["swingBar"],
                        get = function(info)
                            return E.db.lui.modules.unitframes.playerframe.swingBar[info[#info]]
                        end,
                        set = function(info, value)
                            E.db.lui.modules.unitframes.playerframe.swingBar[info[#info]] = value
                            E:StaticPopup_Show("PRIVATE_RL")
                        end,
                        args = {
                            enable = {
                                order = 1,
                                type = "toggle",
                                name = L["Enable"],
                            },
                            spacer1 = {
                                order = 2,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            swingBarColor = {
                                type = "color",
                                order = 3,
                                name = L["swingBarColor"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                                get = function(info)
                                    local t = E.db.lui.modules.unitframes.playerframe.swingBar[info[#info]]
                                    local d = P.lui.modules.unitframes.playerframe.swingBar[info[#info]]
                                    return t.r, t.g, t.b, t.a, d.r, d.g, d.b, d.a
                                end,
                                set = function(info, r, g, b, a)
                                    E.db.lui.modules.unitframes.playerframe.swingBar[info[#info]] = {}
                                    local t = E.db.lui.modules.unitframes.playerframe.swingBar[info[#info]]
                                    t.r, t.g, t.b, t.a = r, g, b, a
                                    E:StaticPopup_Show("PRIVATE_RL")
                                end,
                            },
                            swingBarWidth = {
                                order = 4,
                                type = "range",
                                min = 20, max = 600, step = 1,
                                name = L["swingBarWidth"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            swingBarHeight = {
                                order = 5,
                                type = "range",
                                min = 1, max = 200, step = 1,
                                name = L["swingBarHeight"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            spacer2 = {
                                order = 6,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            remainingText = {
                                order = 7,
                                type = "toggle",
                                name = L["remainingText"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            durationText = {
                                order = 8,
                                type = "toggle",
                                name = L["durationText"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            spacer3 = {
                                order = 9,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            swingBarFontName = {
                                order = 10,
                                type = "select",
                                dialogControl = "LSM30_Font",
                                values = LUI.fontName,
                                name = L["swingBarFontName"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            swingBarFontSize = {
                                order = 11,
                                type = "range",
                                min = 4, max = 212, step = 1,
                                name = L["swingBarFontSize"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                            swingBarFontFlag = {
                                order = 12,
                                type = "select",
                                values = LUI.fontFlagValues,
                                name = L["swingBarFontFlag"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.playerframe.swingBar["enable"]
                                end,
                            },
                        }
                    }
                }
            },
            targetframe = {
                order = 3,
                type = "group",
                name = L["targetframe"],
                get = function(info)
                    return E.db.lui.modules.unitframes.targetframe[info[#info]]
                end,
                set = function(info, value)
                    E.db.lui.modules.unitframes.targetframe[info[#info]] = value
                end,
                args = {
                    rangeText = {
                        order = 1,
                        type = "group",
                        guiInline = true,
                        name = L["rangeText"],
                        get = function(info)
                            return E.db.lui.modules.unitframes.targetframe.rangeText[info[#info]]
                        end,
                        set = function(info, value)
                            E.db.lui.modules.unitframes.targetframe.rangeText[info[#info]] = value
                            E:StaticPopup_Show("PRIVATE_RL")
                        end,
                        args = {
                            enable = {
                                order = 1,
                                type = "toggle",
                                name = L["Enable"],
                            },
                            spacer1 = {
                                order = 2,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            rangeFontName = {
                                order = 3,
                                type = "select",
                                dialogControl = "LSM30_Font",
                                values = LUI.fontName,
                                name = L["rangeFontName"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            rangeFontSize = {
                                order = 4,
                                type = "range",
                                min = 4, max = 212, step = 1,
                                name = L["rangeFontSize"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            rangeFontFlag = {
                                order = 5,
                                type = "select",
                                values = LUI.fontFlagValues,
                                name = L["rangeFontFlag"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            spacer2 = {
                                order = 6,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            rangePoi = {
                                order = 7,
                                type = "select",
                                values = LUI.positionValues,
                                name = L["rangePoi"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            rangePoiX = {
                                order = 8,
                                type = "range",
                                min = -500, max = 500, step = 1,
                                name = L["rangePoiX"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            },
                            rangePoiY = {
                                order = 9,
                                type = "range",
                                min = -500, max = 500, step = 1,
                                name = L["rangePoiY"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.targetframe.rangeText["enable"]
                                end,
                            }
                        }
                    }
                }
            },
            focusframe = {
                order = 4,
                type = "group",
                name = L["focusframe"],
                get = function(info)
                    return E.db.lui.modules.unitframes.focusframe[info[#info]]
                end,
                set = function(info, value)
                    E.db.lui.modules.unitframes.focusframe[info[#info]] = value
                end,
                args = {
                    rangeText = {
                        order = 1,
                        type = "group",
                        guiInline = true,
                        get = function(info)
                            return E.db.lui.modules.unitframes.focusframe.rangeText[info[#info]]
                        end,
                        set = function(info, value)
                            E.db.lui.modules.unitframes.focusframe.rangeText[info[#info]] = value
                            E:StaticPopup_Show("PRIVATE_RL")
                        end,
                        name = L["rangeText"],
                        args = {
                            enable = {
                                order = 1,
                                type = "toggle",
                                name = L["Enable"],
                            },
                            spacer1 = {
                                order = 2,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            rangeFontName = {
                                order = 3,
                                type = "select",
                                dialogControl = "LSM30_Font",
                                values = LUI.fontName,
                                name = L["rangeFontName"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            rangeFontSize = {
                                order = 4,
                                type = "range",
                                min = 4, max = 212, step = 1,
                                name = L["rangeFontSize"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            rangeFontFlag = {
                                order = 5,
                                type = "select",
                                values = LUI.fontFlagValues,
                                name = L["rangeFontFlag"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            spacer2 = {
                                order = 6,
                                type = "description",
                                name = "",
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            rangePoi = {
                                order = 7,
                                type = "select",
                                values = LUI.positionValues,
                                name = L["rangePoi"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            rangePoiX = {
                                order = 8,
                                type = "range",
                                min = -500, max = 500, step = 1,
                                name = L["rangePoiX"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            },
                            rangePoiY = {
                                order = 9,
                                type = "range",
                                min = -500, max = 500, step = 1,
                                name = L["rangePoiY"],
                                hidden = function(info)
                                    return not E.db.lui.modules.unitframes.focusframe.rangeText["enable"]
                                end,
                            }
                        }
                    }
                }
            }
        }
    }
end
T.table_insert(LUI.Configs, configTable)
